//Busca: A Search Engine
//
//Jon Vote - 2004
//
//Idioma Software Inc. 
//www.idioma-software.com
//www.skycoder.com 
//jon@idioma-software.com 
//
//541-488-1972 (USA)

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Busca
{
	/// <summary>
	/// Search WebLex Database
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.Button btnSearch;
		protected System.Web.UI.WebControls.RadioButtonList rbAnyAll;
		protected System.Web.UI.WebControls.DataGrid dgResults;
		protected System.Web.UI.WebControls.Label lblNoResults;
		protected System.Data.SqlClient.SqlDataAdapter daWebLex;
		protected System.Data.SqlClient.SqlCommand sqlSelectCommand1;
		protected Busca.DataSet1 dsWebLex;
		protected System.Data.SqlClient.SqlConnection conWebLex;
		
		private const int MAX_UBOUND_WORDS = 9;

		//Page_Load 
		private void Page_Load(object sender, System.EventArgs e)
		{
		    //Set btnSearch as default
			Page.RegisterHiddenField("__EVENTTARGET", "btnSearch");

			//Populate or clear the grid
			PopulateGrid();
		}

		 //PopulateGrid: Apply the search if any
		private void PopulateGrid()
		{
        //Set Search Type - Any or All
		if (rbAnyAll.Items[0].Selected)
            daWebLex.SelectCommand.Parameters["@SearchType"].Value = 0;
        else
            daWebLex.SelectCommand.Parameters["@SearchType"].Value = 1;
        
        //The search paramters, if any
        //will be found in the ViewState
        //Set these when found
        bool bSearching = false;
        int i = 0;
        for (i = 0; i<= MAX_UBOUND_WORDS; i++) 
			daWebLex.SelectCommand.Parameters["@Word" + i].Value 
				= null;
			if (ViewState["@Word" + i] != null)
				if ((string)ViewState["@Word" + i] != "")
				{
					bSearching = true;
					daWebLex.SelectCommand.Parameters["@Word" + i].Value  
						= (string) ViewState["@Word" + i];
				}
        //Refresh the display
		dsWebLex.Clear();
		daWebLex.Fill(dsWebLex);
		DataBind();

        //Hide or show the grid depending
        //on the results
			if (dgResults.Items.Count == 0)
			{
				dgResults.Visible = false;
				if (bSearching)
					lblNoResults.Visible = true;
			}
			else
			{
				dgResults.Visible = true;
				lblNoResults.Visible = false;
				UpdateFooter();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.daWebLex = new System.Data.SqlClient.SqlDataAdapter();
			this.sqlSelectCommand1 = new System.Data.SqlClient.SqlCommand();
			this.conWebLex = new System.Data.SqlClient.SqlConnection();
			this.dsWebLex = new Busca.DataSet1();
			((System.ComponentModel.ISupportInitialize)(this.dsWebLex)).BeginInit();
			this.dgResults.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.dgResults_PageIndexChanged);
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			// 
			// daWebLex
			// 
			this.daWebLex.SelectCommand = this.sqlSelectCommand1;
			this.daWebLex.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																							   new System.Data.Common.DataTableMapping("Table", "dbo.SearchWebLex", new System.Data.Common.DataColumnMapping[] {
																																																				   new System.Data.Common.DataColumnMapping("Title", "Title"),
																																																				   new System.Data.Common.DataColumnMapping("URL", "URL")}),
																							   new System.Data.Common.DataTableMapping("Table1", "Table1", new System.Data.Common.DataColumnMapping[] {
																																																		  new System.Data.Common.DataColumnMapping("Title", "Title"),
																																																		  new System.Data.Common.DataColumnMapping("URL", "URL")})});
			// 
			// sqlSelectCommand1
			// 
			this.sqlSelectCommand1.CommandText = "dbo.[SearchWebLex]";
			this.sqlSelectCommand1.CommandType = System.Data.CommandType.StoredProcedure;
			this.sqlSelectCommand1.Connection = this.conWebLex;
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@RETURN_VALUE", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.ReturnValue, false, ((System.Byte)(10)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, null));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@SearchType", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, null));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word0", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word1", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word2", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word3", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word4", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word5", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word6", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word7", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word8", System.Data.SqlDbType.VarChar, 30));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Word9", System.Data.SqlDbType.VarChar, 30));
			// 
			// conWebLex
			// 
			this.conWebLex.ConnectionString = "data source=Dell340\\Dell340;initial catalog=dbWebLex;password=search;persist secu" +
				"rity info=True;user id=weblex;workstation id=DELL340;packet size=4096";
			// 
			// dsWebLex
			// 
			this.dsWebLex.DataSetName = "DataSet1";
			this.dsWebLex.Locale = new System.Globalization.CultureInfo("en-US");
			this.dsWebLex.Namespace = "http://www.tempuri.org/DataSet1.xsd";
			this.Load += new System.EventHandler(this.Page_Load);
			((System.ComponentModel.ISupportInitialize)(this.dsWebLex)).EndInit();

		}
		#endregion

		private void dgResults_PageIndexChanged
			(object source, 
				System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			dgResults.CurrentPageIndex = e.NewPageIndex;
			DataBind();
			UpdateFooter();
		}

		//Parse the search paramters 
		//and populate the ViewState
		private void SetSearchParms()
		{
			//Words to search for 
			int i = 0;
			string[] strWords = ParseWords
				 (StripSpecialCharacters(txtSearch.Text));
			if (!(strWords == null))
			{
				int intUBound  = strWords.Length;
				if (intUBound > MAX_UBOUND_WORDS)
					intUBound = MAX_UBOUND_WORDS;
            for (i = 0; i <= MAX_UBOUND_WORDS; i++)
                ViewState["@Word" + i] = null;

			    for (i = 0; i < intUBound; i++)
				{
					if (strWords[i] != "")
						ViewState["@Word" + i] = strWords[i];
				}
			}
			dgResults.CurrentPageIndex = 0;
		}
	
	    //ParseWords: Strip special characters, return list of search words
		private string[] ParseWords(string strText)
		{
	        if ((strText == null) | (strText == ""))
		        return(null);
			else
			{
				//Match all the words 
				string strMatchWords = "\\w+";
				System.Text.RegularExpressions.MatchCollection mc 
				= System.Text.RegularExpressions.Regex.Matches(strText, strMatchWords);
				string[] strWords  = new string[mc.Count];
				int i = 0;
				for (i = 0; i < strWords.Length; i++) 
					strWords[i] = mc[i].Value;
				return(strWords);
			}
		}

		private string StripSpecialCharacters(string strContent)
		{
			string[] strTreatAsBlank = {"\t", "\n", "\r", "&", @"\*", @"\+", ",", ";", "-", @"\.", "/", "{", "}", @"\|", "~", "<", ">", ":", "=", "_"};
			string[] strTreatAsNull = {"!", @"""", "#", @"\$", "%", "'", @"\(", @"\)", @"\[", @"\]", @"\?", "@", "","^"};
			int i = 0;

			//Treat as blank characters to blank
			for (i = 0; i < strTreatAsBlank.Length; i++)
				strContent = System.Text.RegularExpressions.Regex.Replace(strContent, strTreatAsBlank[i], " ");

			//Treat as null characters to null
			for (i = 0; i < strTreatAsNull.Length; i++)
				strContent = System.Text.RegularExpressions.Regex.Replace(strContent, strTreatAsNull[i], "");
			return strContent;
		}

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			SetSearchParms();
			PopulateGrid();
		}

		private void UpdateFooter()
		{
			int intFirstItem 
				= dgResults.CurrentPageIndex  
					* dgResults.PageSize + 1;
			int intLastItem  
	            = intFirstItem  
		         + dgResults.PageSize - 1;
			if (intLastItem > dsWebLex.Tables[0].Rows.Count)
				intLastItem = dsWebLex.Tables[0].Rows.Count;

			const int COL_OUTPUT = 2;
			dgResults.Columns[COL_OUTPUT].FooterText  
				= "Items: " + intFirstItem  
	             + " to " + intLastItem.ToString()
		          + " of " + dsWebLex.Tables[0].Rows.Count.ToString();
			DataBind();
		}
	}
}